/* ***********************************************************
 * This file was automatically generated on 2024-04-08.      *
 *                                                           *
 * C# Bindings Version 2.1.33                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures relative humidity
	/// </summary>
	public class BrickletHumidity : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 27;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Humidity Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_HUMIDITY = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_HUMIDITY_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_HUMIDITY_CALLBACK_PERIOD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_HUMIDITY_CALLBACK_THRESHOLD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_HUMIDITY_CALLBACK_THRESHOLD = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_HUMIDITY = 13;

		private const int CALLBACK_ANALOG_VALUE = 14;

		private const int CALLBACK_HUMIDITY_REACHED = 15;

		private const int CALLBACK_ANALOG_VALUE_REACHED = 16;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletHumidity.SetHumidityCallbackPeriod"/>. The parameter is the humidity of
		///  the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletHumidity.HumidityCallback"/> callback is only triggered if the humidity has changed since
		///  the last triggering.
		/// </summary>
		public event HumidityEventHandler HumidityCallback;
		/// <summary>
		/// </summary>
		public delegate void HumidityEventHandler(BrickletHumidity sender, int humidity);

		/// <summary>
		/// </summary>
		public event HumidityEventHandler Humidity // for backward compatibility
		{
			add { HumidityCallback += value; }
			remove { HumidityCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletHumidity.SetAnalogValueCallbackPeriod"/>. The parameter is the analog
		///  value of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletHumidity.AnalogValueCallback"/> callback is only triggered if the humidity has changed
		///  since the last triggering.
		/// </summary>
		public event AnalogValueEventHandler AnalogValueCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueEventHandler(BrickletHumidity sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueEventHandler AnalogValue // for backward compatibility
		{
			add { AnalogValueCallback += value; }
			remove { AnalogValueCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletHumidity.SetHumidityCallbackThreshold"/> is reached.
		///  The parameter is the humidity of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletHumidity.SetDebouncePeriod"/>.
		/// </summary>
		public event HumidityReachedEventHandler HumidityReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void HumidityReachedEventHandler(BrickletHumidity sender, int humidity);

		/// <summary>
		/// </summary>
		public event HumidityReachedEventHandler HumidityReached // for backward compatibility
		{
			add { HumidityReachedCallback += value; }
			remove { HumidityReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletHumidity.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletHumidity.SetDebouncePeriod"/>.
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueReachedEventHandler(BrickletHumidity sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReached // for backward compatibility
		{
			add { AnalogValueReachedCallback += value; }
			remove { AnalogValueReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletHumidity(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_HUMIDITY] = new CallbackWrapper(OnHumidityCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE] = new CallbackWrapper(OnAnalogValueCallback);
			callbackWrappers[CALLBACK_HUMIDITY_REACHED] = new CallbackWrapper(OnHumidityReachedCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE_REACHED] = new CallbackWrapper(OnAnalogValueReachedCallback);


			responseExpected[FUNCTION_GET_HUMIDITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_HUMIDITY_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_HUMIDITY_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_HUMIDITY_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_HUMIDITY_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the humidity of the sensor.
		///  
		///  If you want to get the humidity periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletHumidity.HumidityCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletHumidity.SetHumidityCallbackPeriod"/>.
		/// </summary>
		public int GetHumidity()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_HUMIDITY);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the value as read by a 12-bit analog-to-digital converter.
		///  
		///  <note>
		///   The value returned by <see cref="Tinkerforge.BrickletHumidity.GetHumidity"/> is averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletHumidity.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The returned humidity value is calibrated for
		///   room temperatures, if you use the sensor in extreme cold or extreme
		///   warm environments, you might want to calculate the humidity from
		///   the analog value yourself. See the `HIH 5030 datasheet
		///   &lt;https://github.com/Tinkerforge/humidity-bricklet/raw/master/datasheets/hih-5030.pdf&gt;`__.
		///  </note>
		///  
		///  If you want the analog value periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletHumidity.AnalogValueCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletHumidity.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public int GetAnalogValue()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletHumidity.HumidityCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletHumidity.HumidityCallback"/> callback is only triggered if the humidity has changed
		///  since the last triggering.
		/// </summary>
		public void SetHumidityCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_HUMIDITY_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletHumidity.SetHumidityCallbackPeriod"/>.
		/// </summary>
		public long GetHumidityCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_HUMIDITY_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletHumidity.AnalogValueCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletHumidity.AnalogValueCallback"/> callback is only triggered if the analog value has
		///  changed since the last triggering.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletHumidity.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public long GetAnalogValueCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletHumidity.HumidityReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the humidity is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the humidity is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the humidity is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the humidity is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetHumidityCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_HUMIDITY_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletHumidity.SetHumidityCallbackThreshold"/>.
		/// </summary>
		public void GetHumidityCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_HUMIDITY_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletHumidity.AnalogValueReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletHumidity.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletHumidity.HumidityReachedCallback"/>,
		///  * <see cref="Tinkerforge.BrickletHumidity.AnalogValueReachedCallback"/>
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletHumidity.SetHumidityCallbackThreshold"/>,
		///  * <see cref="Tinkerforge.BrickletHumidity.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletHumidity.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnHumidityCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int humidity = LEConverter.UShortFrom(8, response);
			var handler = HumidityCallback;

			if (handler != null)
			{
				handler(this, humidity);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnHumidityReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int humidity = LEConverter.UShortFrom(8, response);
			var handler = HumidityReachedCallback;

			if (handler != null)
			{
				handler(this, humidity);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueReachedCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}
	}
}
